#ifndef OBJECT_H_
#define OBJECT_H_

#include <graphx.h>
#include "sprite.h"

typedef struct Scale {
    int x;
    int y;
} Scale;
typedef struct Object Object;
typedef void (*Object_func)(Object*);
typedef int (*Object_func_int)(Object*);
struct Object {
    int id;
    int x;
    int y;
    Scale scale;
    Sprite* sprite;
    struct Scene* scene;

    Object_func_int height;
    Object_func_int width;
    Object_func draw;
    Object_func update;
    Object_func load;
    Object_func free;
};

void Object_draw(Object* self);
void free_Object(Object* self);
Object* new_Object(int x, int y);

#endif
